# module Process::Sys

The `Process::Sys` module contains `UID` and `GID` functions which provide direct bindings to the system calls of the same names instead of the more-portable versions of the same functionality found in the `Process`, `Process::UID`, and `Process::GID` modules.

### Public Class Methods

egid → integer
Process::GID.eid → integer
Process::Sys.geteid → integer
Source

    static VALUE
    proc_getegid(VALUE obj)
    {
        rb_gid_t egid = getegid();

        return GIDT2NUM(egid);
    }

Returns the effective group ID for the current process:

    Process.egid # => 500

Not available on all platforms.

euid → integer
Process::UID.eid → integer
Process::Sys.geteuid → integer
Source

    static VALUE
    proc_geteuid(VALUE obj)
    {
        rb_uid_t euid = geteuid();
        return UIDT2NUM(euid);
    }

Returns the effective user ID for the current process.

    Process.euid # => 501

gid → integer
Process::GID.rid → integer
Process::Sys.getgid → integer
Source

    static VALUE
    proc_getgid(VALUE obj)
    {
        rb_gid_t gid = getgid();
        return GIDT2NUM(gid);
    }

Returns the (real) group ID for the current process:

    Process.gid # => 1000

uid → integer
Process::UID.rid → integer
Process::Sys.getuid → integer
Source

    static VALUE
    proc_getuid(VALUE obj)
    {
        rb_uid_t uid = getuid();
        return UIDT2NUM(uid);
    }

Returns the (real) user ID of the current process.

    Process.uid # => 1000

Process::Sys.issetugid → true or false
Source

    static VALUE
    p_sys_issetugid(VALUE obj)
    {
        return RBOOL(issetugid());
    }

Returns `true` if the process was created as a result of an execve(2) system call which had either of the setuid or setgid bits set (and extra privileges were given as a result) or if it has changed any of its real, effective or saved user or group IDs since it began execution.

Process::Sys.setegid(group) → nil
Source

    static VALUE
    p_sys_setegid(VALUE obj, VALUE id)
    {
        check_gid_switch();
        if (setegid(OBJ2GID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the effective group ID of the calling process to group. Not available on all platforms.

Process::Sys.seteuid(user) → nil
Source

    static VALUE
    p_sys_seteuid(VALUE obj, VALUE id)
    {
        check_uid_switch();
        if (seteuid(OBJ2UID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the effective user ID of the calling process to user. Not available on all platforms.

Process::Sys.setgid(group) → nil
Source

    static VALUE
    p_sys_setgid(VALUE obj, VALUE id)
    {
        check_gid_switch();
        if (setgid(OBJ2GID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the group ID of the current process to group. Not available on all platforms.

Process::Sys.setregid(rid, eid) → nil
Source

    static VALUE
    p_sys_setregid(VALUE obj, VALUE rid, VALUE eid)
    {
        rb_gid_t rgid, egid;
        check_gid_switch();
        rgid = OBJ2GID(rid);
        egid = OBJ2GID(eid);
        if (setregid(rgid, egid) != 0) rb_sys_fail(0);
        return Qnil;
    }

Sets the (group) real and/or effective group IDs of the current process to rid and eid, respectively. A value of `-1` for either means to leave that ID unchanged. Not available on all platforms.

Process::Sys.setresgid(rid, eid, sid) → nil
Source

    static VALUE
    p_sys_setresgid(VALUE obj, VALUE rid, VALUE eid, VALUE sid)
    {
        rb_gid_t rgid, egid, sgid;
        check_gid_switch();
        rgid = OBJ2GID(rid);
        egid = OBJ2GID(eid);
        sgid = OBJ2GID(sid);
        if (setresgid(rgid, egid, sgid) != 0) rb_sys_fail(0);
        return Qnil;
    }

Sets the (group) real, effective, and saved user IDs of the current process to rid, eid, and sid respectively. A value of `-1` for any value means to leave that ID unchanged. Not available on all platforms.

Process::Sys.setresuid(rid, eid, sid) → nil
Source

    static VALUE
    p_sys_setresuid(VALUE obj, VALUE rid, VALUE eid, VALUE sid)
    {
        rb_uid_t ruid, euid, suid;
        PREPARE_GETPWNAM;
        check_uid_switch();
        ruid = OBJ2UID1(rid);
        euid = OBJ2UID1(eid);
        suid = OBJ2UID1(sid);
        FINISH_GETPWNAM;
        if (setresuid(ruid, euid, suid) != 0) rb_sys_fail(0);
        return Qnil;
    }

Sets the (user) real, effective, and saved user IDs of the current process to rid, eid, and sid respectively. A value of `-1` for any value means to leave that ID unchanged. Not available on all platforms.

Process::Sys.setreuid(rid, eid) → nil
Source

    static VALUE
    p_sys_setreuid(VALUE obj, VALUE rid, VALUE eid)
    {
        rb_uid_t ruid, euid;
        PREPARE_GETPWNAM;
        check_uid_switch();
        ruid = OBJ2UID1(rid);
        euid = OBJ2UID1(eid);
        FINISH_GETPWNAM;
        if (setreuid(ruid, euid) != 0) rb_sys_fail(0);
        return Qnil;
    }

Sets the (user) real and/or effective user IDs of the current process to rid and eid, respectively. A value of `-1` for either means to leave that ID unchanged. Not available on all platforms.

Process::Sys.setrgid(group) → nil
Source

    static VALUE
    p_sys_setrgid(VALUE obj, VALUE id)
    {
        check_gid_switch();
        if (setrgid(OBJ2GID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the real group ID of the calling process to group. Not available on all platforms.

Process::Sys.setruid(user) → nil
Source

    static VALUE
    p_sys_setruid(VALUE obj, VALUE id)
    {
        check_uid_switch();
        if (setruid(OBJ2UID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the real user ID of the calling process to user. Not available on all platforms.

Process::Sys.setuid(user) → nil
Source

    static VALUE
    p_sys_setuid(VALUE obj, VALUE id)
    {
        check_uid_switch();
        if (setuid(OBJ2UID(id)) != 0) rb_sys_fail(0);
        return Qnil;
    }

`Set` the user ID of the current process to user. Not available on all platforms.